Index: main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/EditSQLDataSourceHelper.js
===================================================================
--- main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/EditSQLDataSourceHelper.js	(revision 0)
+++ main/plugin-admin/resources/js/Ametys/plugins/admin/datasource/EditSQLDataSourceHelper.js	(revision 0)
@@ -0,0 +1,404 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+
+/**
+ * Helper for the edition of a SQL data source
+ * @private
+ */
+Ext.define('Ametys.plugins.admin.datasource.EditSQLDataSourceHelper', {
+	singleton: true,
+	
+	/**
+	 * @private
+	 * @property {Boolean} _initialized True if the dialog box creation process is finished
+	 */
+	/**
+	 * @private
+	 * @property {String} _mode The current edition mode ('new' or 'edit')
+	 */
+	/**
+	 * @private
+	 * @property {Ametys.window.DialogBox} _box The dialog box
+	 */
+	/**
+	 * @private
+	 * @property {Ext.form.Panel} _form The form panel
+	 */
+	/**
+	 * @private
+	 * @property {Object} _templates the mapping of driver value with their associated template
+	 */
+	/**
+	 * @private
+	 * @property {Function} _callback the callback function
+	 */
+	
+	/**
+	 * Open dialog box to create a new SQL data source
+	 * @param {Function} callback a callback function to invoke after the form is validated, can be null
+	 */
+	add: function (callback)
+	{
+		this._callback = callback;
+		this._mode = 'new';
+		this._open (null);
+	},
+	
+	/**
+	 * Open dialog box to edit a SQL data source
+	 * @param {String} id the id of the selected data source
+	 */
+	edit: function (id)
+	{
+		this._mode = 'edit';
+		this._open (id);
+	},
+	
+	/**
+	 * @private
+	 * Show dialog box for SQL data source edition
+	 * @param {String} id the id of the selected data source in 'edit' mode, null in 'new' mode
+	 */
+	_open: function (id)
+	{
+		var me = this;
+		function configureCallback (success)
+		{
+			if (success)
+			{
+				me._initForm (id);
+				me._box.show();
+			}
+		}
+		
+		// Create dialog box if needed
+		this._createDialogBox(configureCallback);
+	},
+	
+	/**
+	 * @private
+	 * Create the dialog box if it is not already the case
+	 * @param {Function} callback function invoked when the dialog box's drawing is finished
+	 */
+	_createDialogBox: function (callback)
+	{
+		if (!this._initialized)
+		{
+			this._form = Ext.create('Ametys.form.ConfigurableFormPanel', {
+				testURL: Ametys.getPluginDirectPrefix('admin') + '/datasource/test'
+			});
+			
+			this._box = Ext.create('Ametys.window.DialogBox', {
+				title: this._mode == 'new' ? "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_ADD_TITLE'/>" : "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_EDIT_TITLE'/>",
+				icon: Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/' + (this._mode == 'new' ? 'add_16.png' : 'edit_16.png'),
+				
+				layout: 'fit',
+				width: 700,
+				items: [ this._form ],
+				
+				closeAction: 'hide',
+				buttons : [{
+					text: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_OK'/>",
+					handler: Ext.bind(this._ok, this)
+				}, {
+					text: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_CANCEL'/>",
+					handler: Ext.bind(function() {this._box.hide();}, this)
+				}]
+			});
+			
+			this._configureForm(callback);
+		}
+		else
+		{
+			this._box.setTitle(this._mode == 'new' ? "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_ADD_TITLE'/>" : "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_EDIT_TITLE'/>");
+			this._box.setIcon(Ametys.getPluginResourcesPrefix('admin') + '/img/datasource/' + (this._mode == 'new' ? 'add_16.png' : 'edit_16.png'));
+			callback(true);
+		}
+	},
+	
+	/**
+	 * @private
+	 * Configure the {@link Ametys.form.ConfigurableFormPanel}
+	 * @param {Function} callback function invoked when the form configuration is finished
+	 */
+	_configureForm: function(callback)
+	{
+		// Retrieve the handled database types
+		Ametys.data.ServerComm.callMethod({
+			role: "org.ametys.core.datasource.sql.dbtype.SQLDatabaseTypeManager",
+			methodName: "getSQLDatabaseTypes",
+			parameters: [],
+			callback: {
+				handler: this._configureFormCb,
+				arguments: {
+					callback: callback
+				},
+				scope: this
+			},
+			errorMessage: {
+				category: this.self.getName(),
+				msg: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_GET_DRIVERS_ERROR'/>"
+			}
+		});
+	},
+	
+	/**
+	 * @private
+	 * Callback for the form configuration process. Configures the {@link Ametys.form.ConfigurableFormPanel} of the dialog box
+	 * @param {Object} response the server's response
+	 * @param {Array} response.databaseTypes the array of database types
+	 * @param {String} response.databaseTypes.label the label of the current database type
+	 * @param {String} response.databaseTypes.value the value of the current database type
+	 * @param {String} response.databaseTypes.template the template associated to the current database type 
+	 * @param {Object} args the callback arguments
+	 * @param {Function} args.callback the callback function
+	 */
+	_configureFormCb: function(response, args)
+	{
+		var me = this;
+		
+		var databaseTypes = response.databaseTypes;
+		
+		var driverEnumeration = []; // The list of label-value pairs that will be displayed in the form
+		var templateMapping = {}; // The mapping of driver value and associated template
+		
+		Ext.Array.each(databaseTypes, function(databaseType){
+			driverEnumeration.push({label: databaseType.label, value: databaseType.value});
+			
+			templateMapping[databaseType.value] = databaseType.template;
+		});
+			
+		this._templates = templateMapping;
+		
+		var configuration = {};
+		
+		// Id field
+		configuration.id = {
+			hidden: true,
+			type: 'string'
+		};
+		
+		// Type field
+		configuration.type = {
+			hidden: true,
+			type: 'string',
+			'default-value': 'SQL'
+		};
+		
+		// Name field
+		configuration.name = {
+			type: 'string',
+	        label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_NAME'/>",
+	        description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_NAME_DESCRIPTION'/>",
+	        validation: {
+	        	mandatory: true
+	        }
+		};
+		
+		// Description field
+		configuration.description = {
+			type: 'string',
+			widget: 'edition.textarea',
+			'widget-params': {
+				charCounter: false
+			},
+	        label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_DESCRIPTION'/>",
+	        description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_DESCRIPTION_DESCRIPTION'/>"
+		};
+		
+		// Driver field 
+		configuration.driver = {
+			type: 'string',
+			enumeration: driverEnumeration,
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_DRIVER'/>",
+		    description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_DRIVER_DESCRIPTION'/>",
+	        validation: {
+	        	mandatory: true
+	        }
+		};
+		
+		// Url field : depends on which jdbc driver is selected
+		configuration.url = {
+			type: 'string',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_URL'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_URL_DESCRIPTION'/>",
+	        validation: {
+	        	mandatory: true
+	        }
+		};
+		
+		// user field
+		configuration.user = {
+			type: 'string',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_USER'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_USER_DESCRIPTION'/>"
+		};
+		
+		// password field
+		configuration.password = {
+			type: 'password',
+			widget: 'edition.password',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_PASSWORD'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_PASSWORD_DESCRIPTION'/>"
+		};
+		
+		// Private field
+		configuration['private'] = {
+			type: 'boolean',
+			widget: 'edition.checkbox',
+			label: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_PRIVATE'/>",
+			description: "<i18n:text i18n:key='PLUGINS_ADMIN_DATASOURCES_DIALOG_SQL_FIELD_PRIVATE_DESCRIPTION'/>",
+			'param-checker': {
+				id: 'sql-connection-checker-datasource',
+				'small-icon-path': '/plugins/admin/resources/img/datasource/test_sqlconnect_16.png',
+				'medium-icon-path': '/plugins/admin/resources/img/datasource/test_sqlconnect_32.png',
+				'large-icon-path': '/plugins/admin/resources/img/datasource/test_sqlconnect_48.png',
+				'linked-params': ['driver', 'url', 'user', 'password'],
+				'param-ref': 'private',
+				label: "<i18n:text i18n:key='PLUGINS_CORE_SQL_CONNECTION_CHECKER_LABEL' i18n:catalogue='plugin.core-impl'/>",
+				description: "<i18n:text i18n:key='PLUGINS_CORE_SQL_CONNECTION_CHECKER_DESC' i18n:catalogue='plugin.core-impl'/>",
+				order: 1
+			}
+		};
+		
+		this._form.configure(configuration);
+		
+		args.callback(true);
+	},
+	
+ 	/**
+ 	 * @private
+ 	 * Initialize the fields of the form
+ 	 * @param {String} id the id of the data source if in 'edit' mode, null in 'new' mode
+ 	 */
+	_initForm: function (id)
+ 	{
+		var form = this._form.getForm(); 
+		if (!this._initialized)
+		{
+			form.findField('driver').on('change', Ext.bind(this._onDriverChange, this));
+		}
+		
+		// Reset the parameter checker status to 'not tested' and reset the warnings
+		if (this._initialized)
+		{
+			this._form.reset();
+		}
+		
+		this._initialized = true;
+		
+ 		if (id == null) 
+        {
+ 			// FIXME chrome automatically sets the user and password fields... see CMS-6913
+ 	 		this._form.setValues({});
+ 	 		form.reset();
+        }
+ 		else
+ 		{
+ 			Ametys.plugins.admin.datasource.DataSourceDAO.getSQLDataSource([id], this._setValues, {scope: this});
+ 			form.findField('id').setValue(id);
+ 		}
+ 	},
+ 	
+ 	/**
+ 	 * @private
+ 	 * Fill the edition form with the given values
+ 	 * @param {Object} datasource the parameter values for the sql data source
+ 	 * @param {String} datasource.name the name of the data source
+ 	 * @param {String} datasource.description the optional description of the data source
+ 	 * @param {String} datasource.driver the driver used for this data source
+ 	 * @param {String} datasource.url the url of the sql data base
+ 	 * @param {String} datasource.user the optional user of the data base
+ 	 * @param {String} datasource.password the optional password to access the data base with the given user login
+ 	 * @param {Boolean} datasource.private is the data source public or private ?
+ 	 */
+ 	_setValues: function(datasource)
+ 	{
+ 		this._form.setValues({values: datasource});
+ 	},
+ 	
+ 	/**
+ 	 * @private
+ 	 * Check if the data source is valid
+ 	 */
+ 	_ok: function()
+ 	{
+ 		if (!this._form.isValid())
+		{
+ 			return;
+		}
+ 		
+ 		
+ 		// Test the data source
+ 		var paramCheckersDAO = this._form._paramCheckersDAO;
+ 		
+ 		Ext.getBody().mask("<i18n:text i18n:key='PLUGINS_CORE_UI_LOADMASK_DEFAULT_MESSAGE' i18n:catalogue='plugin.core-ui'/>");
+ 		paramCheckersDAO.check(paramCheckersDAO._paramCheckers,
+ 							   true, 
+					           Ext.bind(function(success) 
+				      		   { 
+					              Ext.getBody().unmask(); 
+					              if (success) 
+					              { 
+					            	  this._okCb();
+					              }
+				      	  		}, this), false); 
+ 	},
+ 	
+ 	/**
+ 	 * @private
+ 	 * Submit the form's values
+ 	 */
+	_okCb: function()
+	{
+    	var values = this._form.getValues();
+ 		values['private'] = this._form.getForm().findField('private').getValue();
+    	
+		if (this._mode == 'new')
+		{
+			Ametys.plugins.admin.datasource.DataSourceDAO.addSQLDataSource([values], 
+				function(id) {
+						this._box.hide();
+				 		if (Ext.isFunction(this._callback))
+						{
+				 			this._callback(id);
+						}
+					}, 
+				{scope: this, waitMessage: {target: this._box}}
+			);
+		}
+		else
+		{
+			Ametys.plugins.admin.datasource.DataSourceDAO.editSQLDataSource([values], function() {this._box.hide();}, {scope: this, waitMessage: {target: this._box}});
+		}
+	},
+ 	
+	/**
+	 * @private
+     * Function invoked when the value of the driver field changes
+     * @param {Ametys.form.widget.ComboBox} combo the combobox
+     * @param {String} newValue the new value of the field
+     * @param {String} oldValue the previous value of the field
+	 */
+	_onDriverChange: function(combo, newValue, oldValue)
+	{
+		if (oldValue != newValue)
+		{
+			var form = this._form.getForm();
+			form.findField('url').setValue(this._templates[newValue]);
+		}
+	}
+});
\ No newline at end of file
Index: main/plugin-admin/sitemap.xmap
===================================================================
--- main/plugin-admin/sitemap.xmap	(revision 38980)
+++ main/plugin-admin/sitemap.xmap	(working copy)
@@ -40,6 +40,9 @@
             <map:action name="config-save" src="org.ametys.runtime.plugins.admin.configuration.SaveConfigAction" logger="org.ametys.runtime.plugins.admin.action"/>
             <map:action name="config-test" src="org.ametys.runtime.plugins.admin.configuration.ParameterCheckerAction" logger="org.ametys.runtime.plugins.admin.action"/>
 			<map:action name="restart" src="org.ametys.runtime.plugins.admin.RestartAction" logger="org.ametys.runtime.plugins.admin.action"/>
+		  
+		    <map:action name="datasources" src="org.ametys.runtime.plugins.admin.datasource.GetDataSourcesAction" logger="org.ametys.plugins.admin.datasource.GetDataSourcesAction" />
+		    <map:action name="datasource-test" src="org.ametys.runtime.plugins.admin.datasource.CheckDataSourceAction" logger="org.ametys.runtime.plugins.admin.datasource.TestDataSourceAction" />
 		</map:actions>
         
         <map:readers>
@@ -285,6 +288,22 @@
                 </map:act>
             </map:match>
             
+            <!-- +
+                 | Data sources
+                 + -->
+            <map:match pattern="datasources/get">
+                <map:act type="datasources">
+                    <map:read type="json"/>
+                </map:act>
+            </map:match>
+            
+            <map:match pattern="datasource/test">
+                <map:act type="datasource-test">
+                    <map:generate type="action-result"/>
+                    <map:serialize type="xml"/>
+                </map:act>
+            </map:match>
+            
         </map:pipeline>
     </map:pipelines>
 </map:sitemap>
\ No newline at end of file
Index: main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/CheckDataSourceAction.java
===================================================================
--- main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/CheckDataSourceAction.java	(revision 0)
+++ main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/CheckDataSourceAction.java	(revision 0)
@@ -0,0 +1,140 @@
+package org.ametys.runtime.plugins.admin.datasource;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import org.apache.avalon.framework.parameters.Parameters;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.cocoon.acting.ServiceableAction;
+import org.apache.cocoon.environment.ObjectModelHelper;
+import org.apache.cocoon.environment.Redirector;
+import org.apache.cocoon.environment.Request;
+import org.apache.cocoon.environment.SourceResolver;
+import org.apache.commons.lang.StringUtils;
+
+import org.ametys.core.cocoon.ActionResultGenerator;
+import org.ametys.core.datasource.ldap.LDAPDataSourceManager;
+import org.ametys.core.datasource.ldap.LDAPDataSourceManager.LDAPDataSourceDescriptor;
+import org.ametys.core.datasource.sql.SQLDataSourceManager;
+import org.ametys.core.datasource.sql.dbtype.SQLDatabaseTypeManager;
+import org.ametys.core.util.I18nUtils;
+import org.ametys.plugins.core.impl.checker.LDAPConnectionChecker;
+import org.ametys.plugins.core.impl.checker.SQLConnectionChecker;
+import org.ametys.runtime.i18n.I18nizableText;
+import org.ametys.runtime.parameter.ParameterChecker;
+
+/**
+ * Action allowing to check the validity of a combination of parameters to establish a SQL connection
+ */
+public class CheckDataSourceAction extends ServiceableAction
+{
+    /** The manager for SQL data source */
+    private SQLDataSourceManager _sqlDataSourceManager;
+    
+    /** The manager for SQL data source */
+    private LDAPDataSourceManager _ldapDataSourceManager;
+    
+    /** The manager for SQL database types */
+    private SQLDatabaseTypeManager _sqlDatabaseTypeManager;
+    
+    /** Utility methods helping the management of internationalizable text */
+    private I18nUtils _i18nUtils;
+    
+    @Override
+    public void service(ServiceManager serviceManager) throws ServiceException
+    {
+        _ldapDataSourceManager = (LDAPDataSourceManager) serviceManager.lookup(LDAPDataSourceManager.ROLE);
+        _sqlDataSourceManager = (SQLDataSourceManager) serviceManager.lookup(SQLDataSourceManager.ROLE);
+        _sqlDatabaseTypeManager = (SQLDatabaseTypeManager) serviceManager.lookup(SQLDatabaseTypeManager.ROLE);
+        _i18nUtils = (I18nUtils) serviceManager.lookup(I18nUtils.ROLE);
+    }
+    
+    @Override
+    public Map act(Redirector redirector, SourceResolver resolver, Map objectModel, String source, Parameters parameters) throws Exception
+    {
+        Map<String, String> result = new HashMap<> ();
+        Request request = ObjectModelHelper.getRequest(objectModel);
+        
+        String type = request.getParameter("type");
+        Map<String, String> testParameters = new HashMap<> ();
+        ParameterChecker paramChecker = null;
+        
+        switch (type)
+        {
+            case "SQL":
+                String driver = request.getParameter("driver");
+                
+                if (StringUtils.isNotEmpty(driver))
+                {
+                    I18nizableText driverNotFoundMessageKey = _sqlDatabaseTypeManager.getClassNotFoundMessage(driver);
+                    testParameters.put("driverNotFoundMessage", _i18nUtils.translate(driverNotFoundMessageKey));
+                }
+                
+                testParameters.put("url", request.getParameter("url"));
+                testParameters.put("driver", request.getParameter("driver"));
+                testParameters.put("user", request.getParameter("user"));
+                
+                String password = request.getParameter("password");
+                
+                // A null password => the password is recorded
+                if (password == null)
+                {
+                    String dataSourceId = request.getParameter("id");
+                    Map<String, Object> sqlDataSourceDescription = _sqlDataSourceManager.getSQLDataSourceDescription(dataSourceId);
+                    testParameters.put("password", (String) sqlDataSourceDescription.get("password"));
+                }
+                else
+                {
+                    testParameters.put("password", password);
+                }
+                
+                paramChecker = new SQLConnectionChecker();
+                break;
+                
+            case "LDAP":
+                testParameters.put("baseURL", request.getParameter("baseURL"));
+                testParameters.put("useSSL", request.getParameter("useSSL"));
+                testParameters.put("baseDN", request.getParameter("baseDN"));
+                testParameters.put("followReferrals", request.getParameter("followReferrals"));
+                
+                String authenticationMethod = request.getParameter("authenticationMethod");
+                testParameters.put("authenticationMethod", authenticationMethod);
+                testParameters.put("adminDN", request.getParameter("adminDN"));
+                
+                String adminPassword = request.getParameter("adminPassword");
+                
+                // A null password + an authentication method => the password is recorded
+                if (adminPassword == null && !authenticationMethod.equals("none"))
+                {
+                    String dataSourceId = request.getParameter("id");
+                    LDAPDataSourceDescriptor ldapDataSourceDescription = _ldapDataSourceManager.getLDAPDataSourceDescription(dataSourceId);
+                    testParameters.put("adminPassword", ldapDataSourceDescription.getAdminPassword());
+                }
+                else
+                {
+                    testParameters.put("adminPassword", adminPassword);
+                }
+                
+                paramChecker = new LDAPConnectionChecker();
+                break;
+            
+            default:
+                throw new IllegalArgumentException("Invalid type for check: '" + type + "'.");
+        }
+        
+        try 
+        {
+            paramChecker.check(testParameters); 
+        }
+        catch (Throwable t)
+        {
+            getLogger().error("The test failed: \n" + t.getMessage(), t);
+            String msg = t.getMessage() != null ? t.getMessage() : "Unknown error";
+            result.put(request.getParameter("paramCheckersIds"), msg);
+        }
+        
+        request.setAttribute(ActionResultGenerator.MAP_REQUEST_ATTR, result);
+        return result;
+    }
+}
Index: main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/DataSourceDAO.java
===================================================================
--- main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/DataSourceDAO.java	(revision 0)
+++ main/plugin-admin/src/org/ametys/runtime/plugins/admin/datasource/DataSourceDAO.java	(revision 0)
@@ -0,0 +1,175 @@
+/*
+ *  Copyright 2015 Anyware Services
+ *
+ *  Licensed under the Apache License, Version 2.0 (the "License");
+ *  you may not use this file except in compliance with the License.
+ *  You may obtain a copy of the License at
+ *
+ *      http://www.apache.org/licenses/LICENSE-2.0
+ *
+ *  Unless required by applicable law or agreed to in writing, software
+ *  distributed under the License is distributed on an "AS IS" BASIS,
+ *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
+ *  See the License for the specific language governing permissions and
+ *  limitations under the License.
+ */
+package org.ametys.runtime.plugins.admin.datasource;
+
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import org.apache.avalon.framework.component.Component;
+import org.apache.avalon.framework.service.ServiceException;
+import org.apache.avalon.framework.service.ServiceManager;
+import org.apache.avalon.framework.service.Serviceable;
+
+import org.ametys.core.datasource.ldap.LDAPDataSourceManager;
+import org.ametys.core.datasource.ldap.LDAPDataSourceManager.LDAPDataSourceDescriptor;
+import org.ametys.core.datasource.sql.SQLDataSourceManager;
+import org.ametys.core.ui.Callable;
+import org.ametys.runtime.plugin.component.AbstractLogEnabled;
+
+/**
+ * DAO for the addition/edition/deletion of datasources. Handled data sources types are:
+ *  - SQL
+ *  - LDAP
+ *  - AD
+ */
+public class DataSourceDAO extends AbstractLogEnabled implements Component, Serviceable
+{
+    /** The SQL data source manager */
+    private SQLDataSourceManager _sqlDataSourceManager;
+    
+    /** The SQL data source manager */
+    private LDAPDataSourceManager _ldapDataSourceManager;
+    
+    @Override
+    public void service(ServiceManager manager) throws ServiceException
+    {
+        _sqlDataSourceManager = (SQLDataSourceManager) manager.lookup(SQLDataSourceManager.ROLE);
+        _ldapDataSourceManager = (LDAPDataSourceManager) manager.lookup(LDAPDataSourceManager.ROLE);
+    }
+    
+    /**
+     * Get the sql data source information
+     * @param id The id the data source
+     * @return The data source's information
+     * @throws Exception if an error occurs while retrieving the data source
+     */
+    @Callable
+    public Map<String, Object> getSQLDataSource (String id) throws Exception 
+    {
+        Map<String, Object> sqlDataSource = new HashMap<> ();
+
+        sqlDataSource.putAll(_sqlDataSourceManager.getSQLDataSourceDescription(id));
+        sqlDataSource.put("id", id);
+        sqlDataSource.put("type", "SQL");
+        
+        return sqlDataSource;
+    }
+    
+    /**
+     * Add a sql data source 
+     * @param parameters The parameters of the data source to create
+     * @return The id of the created data source
+     * @throws Exception if an error occurs while retrieving the data source
+     */
+    @Callable
+    public String addSQLDataSource (Map<String, Object> parameters) throws Exception 
+    {
+        return _sqlDataSourceManager.saveSQLDataSource(parameters);
+    }
+
+    /**
+     * Edit a sql data source 
+     * @param parameters The parameters of the data source to edit
+     * @throws Exception if an error occurs while retrieving the data source
+     */
+    @Callable
+    public void editSQLDataSource (Map<String, Object> parameters) throws Exception 
+    {
+        _sqlDataSourceManager.saveSQLDataSource(parameters);
+    }
+    
+    /**
+     * Remove one or several sql data sources 
+     * @param ids the ids of the data sources to remove
+     * @throws Exception if something goes wrong during the sql data source removal process
+     */
+    @Callable
+    public void removeSQLDataSource (List<String> ids) throws Exception
+    {
+        for (String id : ids)
+        {
+            _sqlDataSourceManager.removeSQLDataSource(id);
+        }
+    }
+    
+    /**
+     * Get the ldap data source information
+     * @param id The id the data source
+     * @return The data source's information
+     * @throws Exception if an error occurs while retrieving the data source
+     */
+    @Callable
+    public Map<String, Object> getLDAPDataSource (String id) throws Exception 
+    {
+        Map<String, Object> ldapDataSource = new HashMap<> ();
+        
+        LDAPDataSourceDescriptor dataSourceDescriptor = _ldapDataSourceManager.getLDAPDataSourceDescription(id);
+
+        ldapDataSource.put("id", id);
+        ldapDataSource.put("name", dataSourceDescriptor.getName());
+        ldapDataSource.put("description", dataSourceDescriptor.getDescription());
+        ldapDataSource.put("baseURL", dataSourceDescriptor.getBaseURL());
+        ldapDataSource.put("useSSL", dataSourceDescriptor.isUsingSSL());
+        ldapDataSource.put("baseDN", dataSourceDescriptor.getBaseDN());
+        ldapDataSource.put("aliasDereferencing", dataSourceDescriptor.getAliasDereferencing());
+        ldapDataSource.put("followReferrals", dataSourceDescriptor.isFollowingReferrals());
+        ldapDataSource.put("authenticationMethod", dataSourceDescriptor.getAuthenticationMethod());
+        ldapDataSource.put("adminDN", dataSourceDescriptor.getAdminDN());
+        ldapDataSource.put("adminPassword", dataSourceDescriptor.getAdminPassword());
+        ldapDataSource.put("private", dataSourceDescriptor.isPrivate());
+        ldapDataSource.put("type", "LDAP");
+        
+        return ldapDataSource;
+    }
+    
+    /**
+     * Add a ldap data source 
+     * @param parameters The parameters of the data source to create
+     * @return The id of the created data source
+     * @throws Exception if an error occurs while retrieving the data source
+     */
+    @Callable
+    public String addLDAPDataSource (Map<String, Object> parameters) throws Exception 
+    {
+        return _ldapDataSourceManager.saveLDAPDataSource(parameters);
+    }
+
+    /**
+     * Edit a ldap data source 
+     * @param parameters The parameters of the data source to edit
+     * @throws Exception if an error occurs while retrieving the data source
+     */
+    @Callable
+    public void editLDAPDataSource (Map<String, Object> parameters) throws Exception 
+    {
+        _ldapDataSourceManager.saveLDAPDataSource(parameters);
+    }
+    
+    /**
+     * Remove one or several ldap data source(s) 
+     * @param ids the ids of the data sources to remove
+     * @throws Exception if something goes wrong during the sql data source removal process
+     */
+    @Callable
+    public void removeLDAPDataSource (List<String> ids) throws Exception
+    {
+        for (String id : ids)
+        {
+            _ldapDataSourceManager.removeLDAPDataSource(id);
+        }
+    }
+}
